SystemOrganization addCategory: #Country!

Object subclass: #Country
	instanceVariableNames: 'countryName countryCode currency locale'
	classVariableNames: 'CountryList'
	poolDictionaries: ''
	category: 'Country'!

!Country commentStamp: 'PaulDeBruicker 2/8/2013 11:00' prior: 0!
iso 3166 country codes and names from here:

http://www.iso.org/iso/country_codes/country_codes!

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/10/2014 16:35'!
addCurrencies
	(Smalltalk at: #Currency) notNil
		ifTrue: [ self countryList do: [ :eachCountry | eachCountry currency: (Currency getFromCountryName: eachCountry countryName) ] ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 11:24'!
countryList
	^ CountryList! !

!Country class methodsFor: 'countryList' stamp: 'PaulDeBruicker 2/7/2014 16:15'!
countryListArray
	^ #(#('Afghanistan' 'AF') #('Albania' 'AL') #('Algeria' 'DZ') #('American Samoa' 'AS') #('Andorra' 'AD') #('Angola' 'AO') #('Anguilla' 'AI') #('Antarctica' 'AQ') #('Antigua and Barbuda' 'AG') #('Argentina' 'AR') #('Armenia' 'AM') #('Aruba' 'AW') #('Australia' 'AU') #('Austria' 'AT') #('Azerbaijan' 'AZ') #('Bahamas' 'BS') #('Bahrain' 'BH') #('Bangladesh' 'BD') #('Barbados' 'BB') #('Belarus' 'BY') #('Belgium' 'BE') #('Belize' 'BZ') #('Benin' 'BJ') #('Bermuda' 'BM') #('Bhutan' 'BT') #('Bolivia, Plurinational State of' 'BO') #('Bonaire, Sint Eustatius and Saba' 'BQ') #('Bosnia and Herzegovina' 'BA') #('Botswana' 'BW') #('Bouvet Island' 'BV') #('Brazil' 'BR') #('British Indian Ocean Territory' 'IO') #('Brunei Darussalam' 'BN') #('Bulgaria' 'BG') #('Burkina Faso' 'BF') #('Burundi' 'BI') #('Cambodia' 'KH') #('Cameroon' 'CM') #('Canada' 'CA') #('Cape Verde' 'CV') #('Cayman Islands' 'KY') #('Central African Republic' 'CF') #('Chad' 'TD') #('Chile' 'CL') #('China' 'CN') #('Christmas Island' 'CX') #('Cocos (Keeling) Islands' 'CC') #('Colombia' 'CO') #('Comoros' 'KM') #('Congo' 'CG') #('Congo, the Democratic Republic of the' 'CD') #('Cook Islands' 'CK') #('Costa Rica' 'CR') #('Croatia' 'HR') #('Cuba' 'CU') #('Curaçao' 'CW') #('Cyprus' 'CY') #('Czech Republic' 'CZ') #('Côte d''Ivoire' 'CI') #('Denmark' 'DK') #('Djibouti' 'DJ') #('Dominica' 'DM') #('Dominican Republic' 'DO') #('Ecuador' 'EC') #('Egypt' 'EG') #('El Salvador' 'SV') #('Equatorial Guinea' 'GQ') #('Eritrea' 'ER') #('Estonia' 'EE') #('Ethiopia' 'ET') #('Falkland Islands (Malvinas)' 'FK') #('Faroe Islands' 'FO') #('Fiji' 'FJ') #('Finland' 'FI') #('France' 'FR') #('French Guiana' 'GF') #('French Polynesia' 'PF') #('French Southern Territories' 'TF') #('Gabon' 'GA') #('Gambia' 'GM') #('Georgia' 'GE') #('Germany' 'DE') #('Ghana' 'GH') #('Gibraltar' 'GI') #('Greece' 'GR') #('Greenland' 'GL') #('Grenada' 'GD') #('Guadeloupe' 'GP') #('Guam' 'GU') #('Guatemala' 'GT') #('Guernsey' 'GG') #('Guinea' 'GN') #('Guinea-Bissau' 'GW') #('Guyana' 'GY') #('Haiti' 'HT') #('Heard Island and McDonald Islands' 'HM') #('Holy See (Vatican City State)' 'VA') #('Honduras' 'HN') #('Hong Kong' 'HK') #('Hungary' 'HU') #('Iceland' 'IS') #('India' 'IN') #('Indonesia' 'ID') #('Iran, Islamic Republic of' 'IR') #('Iraq' 'IQ') #('Ireland' 'IE') #('Isle of Man' 'IM') #('Israel' 'IL') #('Italy' 'IT') #('Jamaica' 'JM') #('Japan' 'JP') #('Jersey' 'JE') #('Jordan' 'JO') #('Kazakhstan' 'KZ') #('Kenya' 'KE') #('Kiribati' 'KI') #('Korea, Democratic People''s Republic of' 'KP') #('Korea, Republic of' 'KR') #('Kuwait' 'KW') #('Kyrgyzstan' 'KG') #('Lao People''s Democratic Republic' 'LA') #('Latvia' 'LV') #('Lebanon' 'LB') #('Lesotho' 'LS') #('Liberia' 'LR') #('Libya' 'LY') #('Liechtenstein' 'LI') #('Lithuania' 'LT') #('Luxembourg' 'LU') #('Macao' 'MO') #('Macedonia, the former Yugoslav Republic of' 'MK') #('Madagascar' 'MG') #('Malawi' 'MW') #('Malaysia' 'MY') #('Maldives' 'MV') #('Mali' 'ML') #('Malta' 'MT') #('Marshall Islands' 'MH') #('Martinique' 'MQ') #('Mauritania' 'MR') #('Mauritius' 'MU') #('Mayotte' 'YT') #('Mexico' 'MX') #('Micronesia, Federated States of' 'FM') #('Moldova, Republic of' 'MD') #('Monaco' 'MC') #('Mongolia' 'MN') #('Montenegro' 'ME') #('Montserrat' 'MS') #('Morocco' 'MA') #('Mozambique' 'MZ') #('Myanmar' 'MM') #('Namibia' 'NA') #('Nauru' 'NR') #('Nepal' 'NP') #('Netherlands' 'NL') #('New Caledonia' 'NC') #('New Zealand' 'NZ') #('Nicaragua' 'NI') #('Niger' 'NE') #('Nigeria' 'NG') #('Niue' 'NU') #('Norfolk Island' 'NF') #('Northern Mariana Islands' 'MP') #('Norway' 'NO') #('Oman' 'OM') #('Pakistan' 'PK') #('Palau' 'PW') #('Palestinian Territory, Occupied' 'PS') #('Panama' 'PA') #('Papua New Guinea' 'PG') #('Paraguay' 'PY') #('Peru' 'PE') #('Philippines' 'PH') #('Pitcairn' 'PN') #('Poland' 'PL') #('Portugal' 'PT') #('Puerto Rico' 'PR') #('Qatar' 'QA') #('Romania' 'RO') #('Russian Federation' 'RU') #('Rwanda' 'RW') #('Réunion' 'RE') #('Saint Barthélemy' 'BL') #('Saint Helena, Ascension and Tristan da Cunha' 'SH') #('Saint Kitts and Nevis' 'KN') #('Saint Lucia' 'LC') #('Saint Martin (French part)' 'MF') #('Saint Pierre and Miquelon' 'PM') #('Saint Vincent and the Grenadines' 'VC') #('Samoa' 'WS') #('San Marino' 'SM') #('Sao Tome and Principe' 'ST') #('Saudi Arabia' 'SA') #('Senegal' 'SN') #('Serbia' 'RS') #('Seychelles' 'SC') #('Sierra Leone' 'SL') #('Singapore' 'SG') #('Sint Maarten (Dutch part)' 'SX') #('Slovakia' 'SK') #('Slovenia' 'SI') #('Solomon Islands' 'SB') #('Somalia' 'SO') #('South Africa' 'ZA') #('South Georgia and the South Sandwich Islands' 'GS') #('South Sudan' 'SS') #('Spain' 'ES') #('Sri Lanka' 'LK') #('Sudan' 'SD') #('Suriname' 'SR') #('Svalbard and Jan Mayen' 'SJ') #('Swaziland' 'SZ') #('Sweden' 'SE') #('Switzerland' 'CH') #('Syrian Arab Republic' 'SY') #('Taiwan, Province of China' 'TW') #('Tajikistan' 'TJ') #('Tanzania, United Republic of' 'TZ') #('Thailand' 'TH') #('Timor-Leste' 'TL') #('Togo' 'TG') #('Tokelau' 'TK') #('Tonga' 'TO') #('Trinidad and Tobago' 'TT') #('Tunisia' 'TN') #('Turkey' 'TR') #('Turkmenistan' 'TM') #('Turks and Caicos Islands' 'TC') #('Tuvalu' 'TV') #('Uganda' 'UG') #('Ukraine' 'UA') #('United Arab Emirates' 'AE') #('United Kingdom' 'GB') #('United States' 'US') #('United States Minor Outlying Islands' 'UM') #('Uruguay' 'UY') #('Uzbekistan' 'UZ') #('Vanuatu' 'VU') #('Venezuela, Bolivarian Republic of' 'VE') #('Viet Nam' 'VN') #('Virgin Islands, British' 'VG') #('Virgin Islands, U.S.' 'VI') #('Wallis and Futuna' 'WF') #('Western Sahara' 'EH') #('Yemen' 'YE') #('Zambia' 'ZM') #('Zimbabwe' 'ZW') #('Åland Islands' 'AX'))! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 12:44'!
findByName: aName
	^ self countryList detect: [ :each | each countryName = aName ] ifNone: [ nil ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 13:08'!
findByTwoLetterCode: aTwoLetterCode
	^ self countryList detect: [ :each | each countryCode = aTwoLetterCode ] ifNone: [ self usa ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/19/2015 15:06'!
getRemoteCountryData
	| countryXml |
	[ countryXml := XMLDOMParser parse: self getXMLISOData contents ]
		on: NameLookupFailure
		do: [ 
			Transcript show: 'no network connection'.
			^ self ].
	CountryList := SortedCollection new.
	countryXml firstNode nodes
		do: [ :each | 
			| newCountry |
			newCountry := self new.
			newCountry countryName: (each attributeAt: 'name').
			newCountry countryCode: (each attributeAt: 'alpha-2').
			CountryList add: newCountry ]! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/26/2014 08:01'!
getXMLISOData
	^ self httpClient get: self githubISOXMLURL! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:35'!
githubISOXMLURL
	^ 'https://raw.github.com/lukes/ISO-3166-Countries-with-Regional-Codes/master/all/all.xml'! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/26/2014 08:02'!
httpClient
	^ HTTPAPIClient httpClient! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 12:16'!
initialize
	"
self initialize
"

	self populateCountryList! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 11:37'!
isoXmlUrl

"ISO has started charging 300CHF/year for this data as of Jan 31 2014"
	^ 'http://www.iso.org/iso/home/standards/country_codes/country_names_and_code_elements_xml.htm'! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 16:19'!
populateCountryList
	self useRemoteData
		ifTrue: [ self getRemoteCountryData ]
		ifFalse: [ 
			CountryList := self countryListArray
				collect: [ :each | 
					Country new
						countryName: each first;
						countryCode: each second;
						yourself ] ].
	self addCurrencies! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/8/2013 13:08'!
usa
	^ self findByTwoLetterCode: 'US'! !

!Country class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 2/7/2014 16:18'!
useRemoteData
	"this only works if you have Zodiac installed and the SqueakSSL plugin"

	^ false! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/26/2013 12:08'!
<= aCountry
	^ self countryName caseInsensitiveLessOrEqual: aCountry countryName! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryCode
	^ countryCode! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryCode: anObject
	countryCode := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryName
	^ countryName! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
countryName: anObject
	countryName := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
currency
	^ currency! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
currency: anObject
	currency := anObject! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
locale
	^ locale! !

!Country methodsFor: 'accessing' stamp: 'PaulDeBruicker 2/8/2013 11:25'!
locale: anObject
	locale := anObject! !

!Country methodsFor: 'printing' stamp: 'PaulDeBruicker 2/8/2013 12:18'!
printOn: aStream
	aStream nextPutAll: self countryName! !

!Country methodsFor: 'printing' stamp: 'PaulDeBruicker 2/26/2013 11:43'!
renderOn: html
	html render: self countryName! !
Country initialize!
